	program model_genotypes
	include 'c_all.inc'
	character*255 form1,form2,form3,temp,chrom,ped,gntp
c,chtfile,gntfile
	integer*1 genotemp(maxmark*2)
c read input file names
c	open(1,file='modelgty.par')
c	read(1,'(a255)') chtfile
c	lct=index(chtfile,' ')
c	lct=lct-1
c	read(1,'(a255)') gntfile
c	lgt=index(gntfile,' ')
c	lgt=lgt-1
c	close(1)
c read seed
c        open(1,file='seed')
c	read(1,'(i5)') isee
c	call srand(isee)
c        close(1)
c        call srand(time())
	call rndseed() 
c read loci description
c	print *,chtfile(1:lct),lct,1
c	print *,gntfile(1:lgt),lgt,2
	gntp='gntp.wrk'
	narg=iargc()
	if (narg.lt.2) then
	  print*,'USAGE: modelgty chromosome pedigree <genotypes>'
	  print*,'       chromosome --- file with genetic map and 
     :allelic frequency data'
	  print*,'       pedigree --- file of pedigree data'
	  print*,'       genotypes (optionally) --- output file name'
	  print*,'                 if missed, name "gntp.wrk" used  '
	  stop
	end if
	if (narg.ge.1) call getarg(1,chrom)
	if (narg.ge.2) call getarg(2,ped)
	if (narg.ge.3) call getarg(3,gntp)
	open(1,file=chrom)
cchtfile(1:lct))
	do i=1,8
	read(1,'(a255)') temp
	end do
	read(1,'(a255)') form1
	read(1,'(a255)') form2
	read(1,'(a255)') form3
	read(1,'(a255)') temp
	read(1,form1) nloci
c	print *,' number of loci:',nloci
	if (nloci.gt.maxmark) call sstop('too many loci to model.')
	do i=1,nloci
	read(1,form2) lname(i),nalle(i),pos(i),
     :			(freq(i,1,k),k=1,nalle(i)-1)
	if (nalle(i).gt.maxalle) then
	  temp='too many alleles in locus '//lname(i)
	  call sstop (temp)
	end if
	read(1,form3) (freq(i,2,k),k=1,nalle(i)-1)
	  do iii0=1,2
	  do iii1=2,nalle(i)-1
	  if (freq(i,iii0,iii1-1).lt.0.0) then
	    temp='incorrect frequencies in marker '//lname(i)
	    call sstop(temp)
	  end if
	  freq(i,iii0,iii1)=freq(i,iii0,iii1)+freq(i,iii0,iii1-1)
	  end do
	  if (freq(i,iii0,nalle(i)-1).gt.1.0) then
	    temp='incorrect frequencies in marker '//lname(i)
	    call sstop(temp)
	  end if
	  freq(i,iii0,nalle(i))=1
	  end do
c	print *,lname(i)
c	print '(100f6.3)',(freq(i,1,k),k=1,nalle(i))
c	print '(100f6.3)',(freq(i,2,k),k=1,nalle(i))
	end do
	close(1)
c read pedigree data
	open(1,file=ped)
	read(1,'(i5)') nd
c	print *,' number of individuals:',nd
	if (nd.gt.maxind) call sstop('too many individuals')
	do i=1,nd
	read(1,'(6i5,a12)')(mas(k,i),k=1,6),orignam(i)
	end do
	close(1)
	inf(1)=0
	nped=1
	do i=2,nd
	if (mas(1,i).ne.mas(1,i-1)) then
	  nped=nped+1
	  inf(nped)=i-1
	end if
	end do
	inf(nped+1)=nd
	if (nped.gt.maxped) call sstop('too many pedigrees')
c	print *,' number of pedigrees:',nped
c model founders' genotypes
        do i=1,nd
	do k=1,2
	index2(k,i)=1
	end do
	end do
	call model_founders
c model offspring' genotypes
        idx=1
        do while(idx.ne.0)
	  call model_offspring
	  idx=0
	  do i=1,nd
	  do k=1,2
	    idx=idx+index2(k,i)
	  end do
	  end do
c	  print *,idx
	end do
c write simulated genotypes
	open(1,file=gntp)
	open(2,file='gntp.wrk_tmp')
	write(1,'(2i5)') nd,nloci
	write(1,'(1000a12)')
     :			(lname(j),j=1,nloci)
	do i=1,nd
	write (2,'(5i3,a12,1000i6)') (mas(j,i),j=1,5),orignam(i),
     :				(genotypes(i,1,j),j=1,nloci)
	write (2,'(27x,1000f6.3)') (gent(i,1,j),j=1,nloci)
	write (2,'(27x,1000i6)') (genotypes(i,2,j),j=1,nloci)
	write (2,'(27x,1000f6.3)') (gent(i,2,j),j=1,nloci)
        do j=1,nloci
	  genotemp(j*2-1)=genotypes(i,1,j)
	  genotemp(j*2)=genotypes(i,2,j)
	end do
c	write (1,'(5i3,1000(6x,2i3))') (mas(j,i),j=1,4),mas(6,i),
c     :		(genotemp(j),j=1,nloci*2)
	write (1,'(1000(6x,2i3))') 
     :		(genotemp(j),j=1,nloci*2)
        end do
	close(2)
	close(1)
	end

	subroutine model_founders
	include 'c_all.inc'
	do i0=1,nd
	if (mas(3,i0).eq.0) then ! founder
	  npop=mas(5,i0)
	  if (npop.gt.2.or.npop.lt.1) call sstop('illegal population')
	  do i1=1,2
	  do i2=1,nloci
	  igt=1
	  pran=rndnum()
	  do kk=1,nalle(i2)-1
	    if (pran.gt.freq(i2,npop,kk)) igt=igt+1
	  end do
	  genotypes(i0,i1,i2)=igt
	  gent(i0,i1,i2)=pran
	  end do
	  end do
	  index2(1,i0)=0
	  index2(2,i0)=0
	end if
	end do
	return
	end

	subroutine model_offspring
	include 'c_all.inc'
	integer*1 haploof(maxmark),haplopar(2,maxmark)
	real randof(maxmark)
c	print *,(inf(i),i=1,10)
	do icped=1,nped
	  nbeg=inf(icped)+1
	  nfin=inf(icped+1)
c	  print *,nbeg,nfin
	  do ib=nbeg,nfin
	  do iparent=1,2
	    if (index2(iparent,ib).eq.1) then  ! haplotype not simulated yet
	    nfa=mas(2+iparent,ib)
	    if (index2(1,nfa+nbeg-1)+index2(2,nfa+nbeg-1).eq.0) then 
						! parental genotype is known
	      do iii=1,nloci
	      do kkk=1,2
	        haplopar(kkk,iii)=genotypes(nfa+nbeg-1,kkk,iii)
	      end do
	      end do
	      call model_hap(randof,haploof,haplopar,nloci,maxmark,pos)
	      do iii=1,nloci
	        genotypes(ib,iparent,iii)=haploof(iii)
	        gent(ib,iparent,iii)=randof(iii)
	      end do 
	      index2(iparent,ib)=0
	    end if
	    end if
	  end do
	  end do
	end do
	return
	end

	subroutine model_hap(randof,haploof,haplopar,nloci,maxmark,pos)
	integer*1 haploof(maxmark),haplopar(2,maxmark)
	real randof(maxmark),pos(maxmark)
	ipos=1
	do i=1,nloci
	if (i.eq.1) then 
	  pt=0.5
	else
	  pd=(pos(i)-pos(i-1))*0.01
	  if (pd.lt.0) call sstop('illegal marker order')
	  pt=0.5*(1.0-exp(-2.0*pd))
	  if (pd.ge.300) pt=0.5
	end if
	pran=rndnum()
	randof(i)=pran
	if (pran.le.pt) then 
	if (ipos.eq.1) then 
	  ipos=2
        else
	  ipos=1
	end if
	end if
	haploof(i)=haplopar(ipos,i)
	end do
	return
	end
	
        include 'sstop.f'
	include 'randoml.f'